'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Markup;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Parser = require('./Parser');

var _Parser2 = _interopRequireDefault(_Parser);

var _Element = require('./components/Element');

var _Element2 = _interopRequireDefault(_Element);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*:: type MarkupProps = {
  content: string,
  tagName: string,
};*/ /**
      * @copyright   2016, Miles Johnson
      * @license     https://opensource.org/licenses/MIT
      * 
      */

function Markup(_ref) {
  var content = _ref.content;
  var _ref$tagName = _ref.tagName;
  var tagName = _ref$tagName === undefined ? 'div' : _ref$tagName;

  return _react2.default.createElement(
    _Element2.default,
    { tagName: tagName },
    new _Parser2.default(content).parse()
  );
}

Markup.propTypes = {
  content: _react.PropTypes.string.isRequired,
  tagName: _react.PropTypes.oneOf(['span', 'div', 'p'])
};