'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Matcher2 = require('../Matcher');

var _Matcher3 = _interopRequireDefault(_Matcher2);

var _Emoji = require('../components/Emoji');

var _Emoji2 = _interopRequireDefault(_Emoji);

var _emoji = require('../data/emoji');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2016, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

/*:: import type { MatchResponse, EmojiProps, EmojiOptions } from '../types';*/


var EMOJI_REGEX = new RegExp(_emoji.EMOJI_PATTERN);
var EMOJI_SHORTNAME_REGEX = new RegExp(_emoji.EMOJI_SHORTNAME_PATTERN, 'i');

var EmojiMatcher = function (_Matcher) {
  (0, _inherits3.default)(EmojiMatcher, _Matcher);

  function EmojiMatcher() {
    (0, _classCallCheck3.default)(this, EmojiMatcher);
    return (0, _possibleConstructorReturn3.default)(this, (EmojiMatcher.__proto__ || (0, _getPrototypeOf2.default)(EmojiMatcher)).apply(this, arguments));
  }

  (0, _createClass3.default)(EmojiMatcher, [{
    key: 'factory',


    /**
     * {@inheritDoc}
     */
    value: function factory(match /*: string*/) {
      var props /*: Object*/ = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (this.options.renderUnicode) {
        return props.unicode;
      }

      return _react2.default.createElement(_Emoji2.default, props);
    }

    /**
     * @{inheritDoc}
     */

  }, {
    key: 'getTagName',
    value: function getTagName() {
      return 'span';
    }

    /**
     * {@inheritDoc}
     */

  }, {
    key: 'match',
    value: function match(string /*: string*/) {
      var response = null;

      // Should we convert shortnames to unicode?
      if (this.options.convertShortName && string.indexOf(':') >= 0) {
        response = this.doMatch(string, EMOJI_SHORTNAME_REGEX, function (matches) {
          return {
            shortName: matches[0].toLowerCase()
          };
        });

        if (response) {
          var unicode = _emoji.SHORTNAME_TO_UNICODE[response.shortName];

          // Invalid shortname
          if (!unicode) {
            response = null;

            // We want to render using the unicode value
          } else {
            response.unicode = unicode;
          }
        }
      }

      // Should we convert unicode to SVG/PNG?
      if (this.options.convertUnicode && !response) {
        response = this.doMatch(string, EMOJI_REGEX, function (matches) {
          return {
            unicode: matches[0]
          };
        });
      }

      return response;
    }
  }]);
  return EmojiMatcher;
}(_Matcher3.default);

exports.default = EmojiMatcher;